osl::eval::ml::NonPawnPieceStandCombination Class Reference

`#include <pieceStand.h>`

## Public Types

enum | { ONE_DIM = 5625 , DIM = ONE_DIM * EvalStages }

## Public Member Functions

| NonPawnPieceStandCombination ()

## Static Public Member Functions

static void | setUp (const Weights &weights)
static MultiInt | eval (const NumEffectState &state, const CArray< bool, 2 > &can_check)
static MultiInt | evalWithUpdate (const NumEffectState &state, Move moved, const MultiInt &last_value, const CArray< bool, 2 > &could_check, const CArray< bool, 2 > &can_check)

## Static Private Member Functions

static MultiInt | sumUp (const CArray< int, 6 > &indices, const CArray< MultiInt, 5625 > &values)
static int | index (int rook, int bishop, int gold, int silver, int knight, int lance)

## Static Private Attributes

static CArray< MultiInt, 5625 > | table
static CArray< MultiInt, 5625 > | check_table

## Friends

class | CanCheckNonPawnPieceStandCombination

## Detailed Description

Definition at line 69 of file eval/pieceStand.h.

## Member Enumeration Documentation

## anonymous enum

anonymous enum

Enumerator
ONE_DIM |
DIM |

Definition at line 73 of file eval/pieceStand.h.

## Constructor & Destructor Documentation

## NonPawnPieceStandCombination()

osl::eval::ml::NonPawnPieceStandCombination::NonPawnPieceStandCombination | ( |  | ) |

inline

Definition at line 74 of file eval/pieceStand.h.

## Member Function Documentation

## eval()

osl::MultiInt osl::eval::ml::NonPawnPieceStandCombination::eval | ( | const NumEffectState & | state,
|  | const CArray< bool, 2 > & | can_check )

static

Definition at line 174 of file eval_pieceStand.cc.

References osl::BISHOP, osl::BLACK, check_table, osl::SimpleState::countPiecesOnStand(), osl::GOLD, index(), osl::KNIGHT, osl::LANCE, osl::ROOK, osl::SILVER, table, and osl::WHITE.

Referenced by evalWithUpdate(), and osl::eval::ml::OpenMidEndingEval::OpenMidEndingEval().

## evalWithUpdate()

osl::MultiInt osl::eval::ml::NonPawnPieceStandCombination::evalWithUpdate | ( | const NumEffectState & | state,
|  | Move | moved,
|  | const MultiInt & | last_value,
|  | const CArray< bool, 2 > & | could_check,
|  | const CArray< bool, 2 > & | can_check )

static

Definition at line 203 of file eval_pieceStand.cc.

References eval(), osl::Move::isCapture(), and osl::Move::isDrop().

Referenced by osl::eval::ml::OpenMidEndingEval::updateSub().

## index()

int osl::eval::ml::NonPawnPieceStandCombination::index | ( | int | rook,
|  | int | bishop,
|  | int | gold,
|  | int | silver,
|  | int | knight,
|  | int | lance )

inline static private

Definition at line 86 of file eval/pieceStand.h.

Referenced by eval(), osl::eval::ml::CanCheckNonPawnPieceStandCombination::setUp(), setUp(), and sumUp().

## setUp()

void osl::eval::ml::NonPawnPieceStandCombination::setUp | ( | const Weights & | weights | ) |

static

Definition at line 94 of file eval_pieceStand.cc.

References index(), osl::NStages, ONE_DIM, sumUp(), table, and osl::eval::ml::Weights::value().

## sumUp()

osl::MultiInt osl::eval::ml::NonPawnPieceStandCombination::sumUp | ( | const CArray< int, 6 > & | indices,
|  | const CArray< MultiInt, 5625 > & | values )

static private

Definition at line 62 of file eval_pieceStand.cc.

References index().

Referenced by osl::eval::ml::CanCheckNonPawnPieceStandCombination::setUp(), and setUp().

## Friends And Related Symbol Documentation

## CanCheckNonPawnPieceStandCombination

friend class CanCheckNonPawnPieceStandCombination

friend

Definition at line 71 of file eval/pieceStand.h.

References CanCheckNonPawnPieceStandCombination.

Referenced by CanCheckNonPawnPieceStandCombination.

## Member Data Documentation

## check_table

osl::CArray< osl::MultiInt, 5625 > osl::eval::ml::NonPawnPieceStandCombination::check_table

static private

Definition at line 93 of file eval/pieceStand.h.

Referenced by eval(), and osl::eval::ml::CanCheckNonPawnPieceStandCombination::setUp().

## table

osl::CArray< osl::MultiInt, 5625 > osl::eval::ml::NonPawnPieceStandCombination::table

static private

Definition at line 92 of file eval/pieceStand.h.

Referenced by eval(), and setUp().

The documentation for this class was generated from the following files:

- eval/pieceStand.h
- eval_pieceStand.cc